unit Sierpinski_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TControlPanel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    procedure Sierpinski(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ControlPanel: TControlPanel;

implementation

{$R *.DFM}

procedure TControlPanel.Sierpinski(Sender: TObject);
type  TPixel    = array [1..2] of integer;
      TTriangle = record
           A,B,C:TPixel;
      end;

const Delka=300;
var Level                      :Byte;
    Predch                     :TTriangle;
    Citac                      :Integer;

Procedure DrawTriangle(Triangle:TTriangle;Level:Byte);
var Nasl    :TTriangle;
    AB,BC,AC,T:TPixel;
begin
  if Level=0 then
       begin
         With Triangle do
         begin
           T[1]:=Round((A[1]+B[1]+C[1])/3);
           T[2]:=Round((A[2]+B[2]+C[2])/3);
           With Image1.Canvas do
           begin
             MoveTo(A[1],A[2]);
             LineTo(B[1],B[2]);
             LineTo(C[1],C[2]);
             LineTo(A[1],A[2]);
             FloodFill(T[1],T[2],clBlack,fsBorder);
           end;
         end;
       {  Citac:=succ(Citac);
         if Citac mod 81 = 0 then Application.ProcessMessages;}
         exit;
       end;
  Level:=Level-1;
  With Triangle do
  begin
    AB[1]:=Round((A[1]+B[1])/2);AB[2]:=Round((A[2]+B[2])/2);
    BC[1]:=Round((B[1]+C[1])/2);BC[2]:=Round((B[2]+C[2])/2);
    AC[1]:=Round((A[1]+C[1])/2);AC[2]:=Round((A[2]+C[2])/2);
  end;
  With Nasl do
  begin
    A:=Triangle.A;B:=AB;C:=AC;
  end;
  DrawTriangle(Nasl,Level);
  With Nasl do
  begin
    A:=AB;B:=Triangle.B;C:=BC;
  end;
  DrawTriangle(Nasl,Level);
  With Nasl do
  begin
    A:=AC;B:=BC;C:=Triangle.C;
  end;
  DrawTriangle(Nasl,Level);
end;

begin
  Level:=3;
  With Predch do
    begin A[1]:=0;A[2]:=0;
          B[1]:=Delka;B[2]:=0;
          C[1]:=Trunc(Delka/2);
          C[2]:=Delka;
    end;
  Citac:=0;
  Image1.Canvas.Brush.Color:=clBlack;
  DrawTriangle(Predch,Level);
  end;

procedure TControlPanel.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
